﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Collections
{

    class Program
    {

        static void Main(string[] args)
        {                 
            ReverseArray rArray = new ReverseArray();
            rArray.Array = new [] {1, 2, 3, 4, 5, 6};

            // linq expresion example
            IEnumerable<string> evenReverse = from i in rArray 
                                              where i%2 == 1 
                                              select string.Format("Odd: {0}", i);
            foreach (string item in evenReverse)                           
                Console.WriteLine(item);   
            Console.WriteLine();

            // linq extension methods example
            foreach (string item in Fibonaci(16).Where(x => x % 2 == 0).Select(x => string.Format("even: {0}", x)))
                Console.WriteLine(item);
        }


        /// <summary>
        /// The method that returns collection with fibonaci numbers
        /// </summary>
        /// <param name="count"></param>
        /// <returns></returns>
        static IEnumerable<int> Fibonaci(int count)
        {
            int i = 0, j = 1;            
            while(count-- > 0)
            {
                yield return i;
                j = i + j;
                i = j - i;               
            }
        }

    }


    /// <summary>
    /// The collection implementation example
    /// </summary>
    internal class ReverseArray : IEnumerable<int>
    {

        public int[] Array { get; set; }

        /// <summary>
        /// The method that returns generic enumerator
        /// </summary>
        /// <returns></returns>
        public IEnumerator<int> GetEnumerator()
        {
            for (int i = Array.Length - 1; i >= 0; i--)
                yield return Array[i];
            yield break;
        }


        /// <summary>
        /// The method that returns non-generic enumeratior
        /// </summary>
        /// <returns></returns>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

    }

}
